#include <linux/ioctl.h>

typedef struct {
	uint32_t bytes;
	uint32_t padding0;
	uint64_t addr;
	union {
		void* mappedpages;
		uint64_t padding1;
	};
	uint64_t pages;
	uint64_t index;
} ximea_cam_pcie_unlockmem_args;

typedef struct {
	union {
		void* buffer;
		uint64_t padding0;
	};
	uint32_t bytes;
	uint32_t pages;
	uint64_t write; //ignored, assumed always 0
	union {
		ximea_cam_pcie_unlockmem_args* out;
		uint64_t padding1;
	};
} ximea_cam_pcie_lockmem_args;

#define XIMEA_CAM_PCIE_IOC_MAGIC 'x'

#define XIMEA_CAM_PCIE_IOCLOCKMEM _IOWR(XIMEA_CAM_PCIE_IOC_MAGIC, 3, ximea_cam_pcie_lockmem_args)
#define XIMEA_CAM_PCIE_IOCUNLOCKMEM _IOW(XIMEA_CAM_PCIE_IOC_MAGIC, 4, ximea_cam_pcie_unlockmem_args)
#define XIMEA_CAM_PCIE_IOCSYNCMEM4CPU _IOW(XIMEA_CAM_PCIE_IOC_MAGIC, 10, ximea_cam_pcie_unlockmem_args)
#define XIMEA_CAM_PCIE_IOCSYNCMEM4DEV _IOW(XIMEA_CAM_PCIE_IOC_MAGIC, 11, ximea_cam_pcie_unlockmem_args)
